#pragma once

#include <string>
#include <vector>
#include <map>
#include <set>

////////////////////////////////////////////////////////////////////////
// [AhX̏
////////////////////////////////////////////////////////////////////////

// [AhXɓ͂łő啶
#define NUM_CHAR_MAIL_ADDRESS_MAX	256
// lɓ͂łő啶
#define NUM_CHAR_MAIL_NOTE_MAX	512

class MailAddressInfo {
public:
	// AhX̎
	enum AddressType { AddressEmail = 0, AddressDomain = 1 };

public:
	// RXgN^
	MailAddressInfo();
	// RXgN^
	MailAddressInfo(const char* email, const char* note);

public:
	// AhX̎
	AddressType GetAddressType();
	// [AhX
	std::string& GetMailAddress();
	// l
	std::string& GetNote();

private:
	// [AhX
	std::string m_email;
	// l
	std::string m_note;
	// AhX̎
	AddressType m_addrType;
};

////////////////////////////////////////////////////////////////////////
// zCgXg
////////////////////////////////////////////////////////////////////////

class WhiteList {
public:
	// RXgN^
	WhiteList();

public:
	// [AhXуhC݂邩𓾂
	bool IsExist(const char* email);
	// [AhXуhC݂邩𓾂(zCgXg`FbNp)
	bool IsExistEmailOrDomain(const char* email);
	// [AhX݂ȂA͔l󂩂𓾂
	bool IsNotExistOrNoteIsEmpty(const char* email, bool* pbNoteIsEmpty);
	// [AhX̏𓾂
	std::map<std::string, MailAddressInfo>& GetMailAddressList();
	// [AhX̌𓾂
	int Count();
	// [AhX̏ǉ
	void Add(const char* email, const char* note);
	// 폜
	void Delete(const char* email);
	// XV
	void Update(const char* email, const char* note);
	// ǉ܂͍XV
	void AddOrUpdate(const char* email, const char* note);
	// SNA
	void ClearAll();
	// C|[g
	void Import(const char* filepath);
	// GNX|[g
	void Export(const char* filepath);

public:
	// rp̃IuWFNgݒ肷
	void SetLockObject(CRITICAL_SECTION* pcsWhiteList);

private:
	// rp
	CRITICAL_SECTION* m_pcsWhiteList;

private:
	// [AhX̏
	std::map<std::string, MailAddressInfo> m_mailList;

//
// \[ĝ߂̎
//
public:
	// \[g鍀
	enum SortKey { SortAddrType = 0, SortEmailAddr = 1, SortNote = 2 };

public:
	// \[gs
	void Sort();
	// \[gL[擾/ݒ
	SortKey GetSortKey();
	void SetSortKey(SortKey sortKey);
	// ǂ擾/ݒ
	bool IsAscending();
	void SetAscending(bool bAscending);
	// n Ԗڂ̃[AhX̏Ԃ
	MailAddressInfo& GetAt(int index);
	// w̃[AhX̃CfbNXԂ
	int GetIndex(const char* email);
	// n Ԗڂ̃[AhX̏폜
	bool DeleteAt(int index);

private:
	// \[gL[
	SortKey m_sortKey;
	// ǂ
	bool m_bAscending;
	// \[g̃L[ێ
	std::vector<std::string> m_sortedEMailAddr;
	// ftHgp̒l(ʏ͎gpȂ)
	MailAddressInfo m_emptyMai;
};

////////////////////////////////////////////////////////////////////////
// g̃[AhX̏
////////////////////////////////////////////////////////////////////////

class MyMailAddressInfo {
public:
	// RXgN^
	MyMailAddressInfo();
	// Becky! ̃f[^tH_ݒ肷
	void SetBkDataFolder(char* bkaDataFolder);

public:
	// [AhX̏XV
	void Update();
	// [AhXg̃[AhẌꗗɑ݂邩𓾂
	bool IsExist(const char* email);
	// [AhX̃hCg̃[AhẌꗗɑ݂邩𓾂
	bool IsDomainExist(const char* emailDomain);

private:
	// [{bNX̏i[ݒt@C̃pXꗗ𓾂
	void GetMailBoxInfoFilepathList(std::vector<std::string>& mailBoxInfoFilepathList);

private:
	// Folder.lst ̍ŏIXV
	FILETIME m_lastWTimeFolderList;
	// Becky! ̃f[^tH_ - [Becky! ̃f[^tH_]
	// NOTE: K '\' ŏI悤ɂĂ
	std::string m_bkaDataFolder;
	// Folder.lst ̃pX - [Becky! ̃f[^tH_]\Folder.lst
	std::string m_folderListFilepath;
	// g̃[AhẌꗗ
	std::set<std::string> m_myEmailList;
};

