#include "stdafx.h"

#include <string>
#include "AddressInfo.h"

using namespace System;
using namespace System::Text;
using namespace System::Collections::Generic;
using namespace Microsoft::VisualStudio::TestTools::UnitTesting;

namespace TestBkBsfilWrapper
{
	[TestClass]
	public ref class UnitTestWhiteList
	{
	private:
		TestContext^ testContextInstance;

	public: 
		/// <summary>
		///݂̃eXg̎sɂĂ̏񂨂ы@\
		///񋟂eXg ReLXg擾܂͐ݒ肵܂B
		///</summary>
		property Microsoft::VisualStudio::TestTools::UnitTesting::TestContext^ TestContext
		{
			Microsoft::VisualStudio::TestTools::UnitTesting::TestContext^ get()
			{
				return testContextInstance;
			}
			System::Void set(Microsoft::VisualStudio::TestTools::UnitTesting::TestContext^ value)
			{
				testContextInstance = value;
			}
		};

		#pragma region Additional test attributes
		//
		//eXg쐬ۂɂ́A̒ǉgpł܂:
		//
		//NXōŏ̃eXgsOɁAClassInitialize gpăR[hsĂ
		//[ClassInitialize()]
		//static void MyClassInitialize(TestContext^ testContext) {};
		//
		//NX̃eXgׂĎsAClassCleanup gpăR[hsĂ
		//[ClassCleanup()]
		//static void MyClassCleanup() {};
		//
		//eeXgsOɁATestInitialize gpăR[hsĂ
		//[TestInitialize()]
		//void MyTestInitialize() {};
		//
		//eeXgsɁATestCleanup gpăR[hsĂ
		//[TestCleanup()]
		//void MyTestCleanup() {};
		//
		#pragma endregion 

		//
		// DeleteAt
		//

		[TestMethod]
		void TestDeleteAt1()
		{
			WhiteList wl;
			wl.Add("test3@mail", "l3");
			wl.Add("test2@mail", "l2");
			wl.Add("test1@mail", "l1");

			wl.DeleteAt(1);

			Assert::AreEqual(2, wl.Count());

			MailAddressInfo& mai0 = wl.GetAt(0);
			MailAddressInfo& mai1 = wl.GetAt(1);

			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai0.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai1.GetAddressType());

			Assert::AreEqual(gcnew String("test3@mail"), gcnew String(mai0.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("test1@mail"), gcnew String(mai1.GetMailAddress().c_str()));

			Assert::AreEqual(gcnew String("l3"), gcnew String(mai0.GetNote().c_str()));
			Assert::AreEqual(gcnew String("l1"), gcnew String(mai1.GetNote().c_str()));
		}

		//
		// Sort
		//

		[TestMethod]
		void TestSort1()
		{
			WhiteList wl;
			wl.Add("mail1.com", "hC1");
			wl.Add("mail1@mail1.com", "[1");
			wl.Add("mail2.com", "hC2");
			wl.Add("mail2@mail2.com", "[2");

			wl.SetSortKey(WhiteList::SortAddrType);
			wl.SetAscending(true);
			wl.Sort();

			Assert::AreEqual(4, wl.Count());
			MailAddressInfo& mai0 = wl.GetAt(0);
			MailAddressInfo& mai1 = wl.GetAt(1);
			MailAddressInfo& mai2 = wl.GetAt(2);
			MailAddressInfo& mai3 = wl.GetAt(3);

			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai0.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai1.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai2.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai3.GetAddressType());

			Assert::AreEqual(gcnew String("mail1@mail1.com"), gcnew String(mai0.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail2@mail2.com"), gcnew String(mai1.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail1.com"), gcnew String(mai2.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail2.com"), gcnew String(mai3.GetMailAddress().c_str()));

			Assert::AreEqual(gcnew String("[1"), gcnew String(mai0.GetNote().c_str()));
			Assert::AreEqual(gcnew String("[2"), gcnew String(mai1.GetNote().c_str()));
			Assert::AreEqual(gcnew String("hC1"), gcnew String(mai2.GetNote().c_str()));
			Assert::AreEqual(gcnew String("hC2"), gcnew String(mai3.GetNote().c_str()));
		}

		[TestMethod]
		void TestSort2()
		{
			WhiteList wl;
			wl.Add("mail1.com", "hC1");
			wl.Add("mail1@mail1.com", "[1");
			wl.Add("mail2.com", "hC2");
			wl.Add("mail2@mail2.com", "[2");

			wl.SetSortKey(WhiteList::SortAddrType);
			wl.SetAscending(false);
			wl.Sort();

			Assert::AreEqual(4, wl.Count());
			MailAddressInfo& mai0 = wl.GetAt(0);
			MailAddressInfo& mai1 = wl.GetAt(1);
			MailAddressInfo& mai2 = wl.GetAt(2);
			MailAddressInfo& mai3 = wl.GetAt(3);

			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai0.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai1.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai2.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai3.GetAddressType());

			Assert::AreEqual(gcnew String("mail2.com"), gcnew String(mai0.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail1.com"), gcnew String(mai1.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail2@mail2.com"), gcnew String(mai2.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail1@mail1.com"), gcnew String(mai3.GetMailAddress().c_str()));

			Assert::AreEqual(gcnew String("hC2"), gcnew String(mai0.GetNote().c_str()));
			Assert::AreEqual(gcnew String("hC1"), gcnew String(mai1.GetNote().c_str()));
			Assert::AreEqual(gcnew String("[2"), gcnew String(mai2.GetNote().c_str()));
			Assert::AreEqual(gcnew String("[1"), gcnew String(mai3.GetNote().c_str()));
		}

		[TestMethod]
		void TestSort3()
		{
			WhiteList wl;
			wl.Add("mail1.com", "hC1");
			wl.Add("mail1@mail1.com", "[1");
			wl.Add("mail2.com", "hC2");
			wl.Add("mail2@mail2.com", "[2");

			wl.SetSortKey(WhiteList::SortEmailAddr);
			wl.SetAscending(true);
			wl.Sort();

			Assert::AreEqual(4, wl.Count());
			MailAddressInfo& mai0 = wl.GetAt(0);
			MailAddressInfo& mai1 = wl.GetAt(1);
			MailAddressInfo& mai2 = wl.GetAt(2);
			MailAddressInfo& mai3 = wl.GetAt(3);

			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai0.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai1.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai2.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai3.GetAddressType());
			
			Assert::AreEqual(gcnew String("mail1.com"), gcnew String(mai0.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail1@mail1.com"), gcnew String(mai1.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail2.com"), gcnew String(mai2.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail2@mail2.com"), gcnew String(mai3.GetMailAddress().c_str()));

			Assert::AreEqual(gcnew String("hC1"), gcnew String(mai0.GetNote().c_str()));
			Assert::AreEqual(gcnew String("[1"), gcnew String(mai1.GetNote().c_str()));
			Assert::AreEqual(gcnew String("hC2"), gcnew String(mai2.GetNote().c_str()));
			Assert::AreEqual(gcnew String("[2"), gcnew String(mai3.GetNote().c_str()));
		}

		[TestMethod]
		void TestSort4()
		{
			WhiteList wl;
			wl.Add("mail1.com", "hC1");
			wl.Add("mail1@mail1.com", "[1");
			wl.Add("mail2.com", "hC2");
			wl.Add("mail2@mail2.com", "[2");

			wl.SetSortKey(WhiteList::SortEmailAddr);
			wl.SetAscending(false);
			wl.Sort();

			Assert::AreEqual(4, wl.Count());
			MailAddressInfo& mai0 = wl.GetAt(0);
			MailAddressInfo& mai1 = wl.GetAt(1);
			MailAddressInfo& mai2 = wl.GetAt(2);
			MailAddressInfo& mai3 = wl.GetAt(3);

			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai0.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai1.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai2.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai3.GetAddressType());
			
			Assert::AreEqual(gcnew String("mail2@mail2.com"), gcnew String(mai0.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail2.com"), gcnew String(mai1.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail1@mail1.com"), gcnew String(mai2.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail1.com"), gcnew String(mai3.GetMailAddress().c_str()));

			Assert::AreEqual(gcnew String("[2"), gcnew String(mai0.GetNote().c_str()));
			Assert::AreEqual(gcnew String("hC2"), gcnew String(mai1.GetNote().c_str()));
			Assert::AreEqual(gcnew String("[1"), gcnew String(mai2.GetNote().c_str()));
			Assert::AreEqual(gcnew String("hC1"), gcnew String(mai3.GetNote().c_str()));
		}

		[TestMethod]
		void TestSort5()
		{
			WhiteList wl;
			wl.Add("mail1.com", "hC1");
			wl.Add("mail1@mail1.com", "[1");
			wl.Add("mail2.com", "hC2");
			wl.Add("mail2@mail2.com", "[2");

			wl.SetSortKey(WhiteList::SortNote);
			wl.SetAscending(true);
			wl.Sort();

			Assert::AreEqual(4, wl.Count());
			MailAddressInfo& mai0 = wl.GetAt(0);
			MailAddressInfo& mai1 = wl.GetAt(1);
			MailAddressInfo& mai2 = wl.GetAt(2);
			MailAddressInfo& mai3 = wl.GetAt(3);

			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai0.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai1.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai2.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai3.GetAddressType());
			
			Assert::AreEqual(gcnew String("mail1.com"), gcnew String(mai0.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail2.com"), gcnew String(mai1.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail1@mail1.com"), gcnew String(mai2.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail2@mail2.com"), gcnew String(mai3.GetMailAddress().c_str()));

			Assert::AreEqual(gcnew String("hC1"), gcnew String(mai0.GetNote().c_str()));
			Assert::AreEqual(gcnew String("hC2"), gcnew String(mai1.GetNote().c_str()));
			Assert::AreEqual(gcnew String("[1"), gcnew String(mai2.GetNote().c_str()));
			Assert::AreEqual(gcnew String("[2"), gcnew String(mai3.GetNote().c_str()));
		}

		[TestMethod]
		void TestSort6()
		{
			WhiteList wl;
			wl.Add("mail1.com", "hC1");
			wl.Add("mail1@mail1.com", "[1");
			wl.Add("mail2.com", "hC2");
			wl.Add("mail2@mail2.com", "[2");

			wl.SetSortKey(WhiteList::SortNote);
			wl.SetAscending(false);
			wl.Sort();

			Assert::AreEqual(4, wl.Count());
			MailAddressInfo& mai0 = wl.GetAt(0);
			MailAddressInfo& mai1 = wl.GetAt(1);
			MailAddressInfo& mai2 = wl.GetAt(2);
			MailAddressInfo& mai3 = wl.GetAt(3);

			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai0.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressEmail, (int) mai1.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai2.GetAddressType());
			Assert::AreEqual((int) MailAddressInfo::AddressDomain, (int) mai3.GetAddressType());
			
			Assert::AreEqual(gcnew String("mail2@mail2.com"), gcnew String(mai0.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail1@mail1.com"), gcnew String(mai1.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail2.com"), gcnew String(mai2.GetMailAddress().c_str()));
			Assert::AreEqual(gcnew String("mail1.com"), gcnew String(mai3.GetMailAddress().c_str()));

			Assert::AreEqual(gcnew String("[2"), gcnew String(mai0.GetNote().c_str()));
			Assert::AreEqual(gcnew String("[1"), gcnew String(mai1.GetNote().c_str()));
			Assert::AreEqual(gcnew String("hC2"), gcnew String(mai2.GetNote().c_str()));
			Assert::AreEqual(gcnew String("hC1"), gcnew String(mai3.GetNote().c_str()));
		}
	};
}
